/* A Bison parser, made by GNU Bison 2.0a.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ID = 258,
     OP = 259,
     ADD = 260,
     SUBTRACT = 261,
     TIMES = 262,
     DIVIDE = 263,
     MOD = 264,
     EXPONENT = 265,
     DOTS = 266,
     COLONS = 267,
     DASHES = 268,
     LONGDASH = 269,
     INCR = 270,
     CONTROLS = 271,
     TENSION = 272,
     ATLEAST = 273,
     CURL = 274,
     CYCLE = 275,
     COR = 276,
     CAND = 277,
     EQ = 278,
     NEQ = 279,
     LT = 280,
     LE = 281,
     GT = 282,
     GE = 283,
     CARETS = 284,
     LOGNOT = 285,
     STRING = 286,
     LOOSE = 287,
     ASSIGN = 288,
     DIRTAG = 289,
     JOIN_PREC = 290,
     AND = 291,
     ELLIPSIS = 292,
     IMPORT = 293,
     STRUCT = 294,
     TYPEDEF = 295,
     NEW = 296,
     IF = 297,
     ELSE = 298,
     WHILE = 299,
     DO = 300,
     FOR = 301,
     BREAK = 302,
     CONTINUE = 303,
     RETURN_ = 304,
     STATIC = 305,
     PUBLIC_TOK = 306,
     PRIVATE_TOK = 307,
     THIS = 308,
     EXPLICIT = 309,
     LIT = 310,
     UNARY = 311
   };
#endif
#define ID 258
#define OP 259
#define ADD 260
#define SUBTRACT 261
#define TIMES 262
#define DIVIDE 263
#define MOD 264
#define EXPONENT 265
#define DOTS 266
#define COLONS 267
#define DASHES 268
#define LONGDASH 269
#define INCR 270
#define CONTROLS 271
#define TENSION 272
#define ATLEAST 273
#define CURL 274
#define CYCLE 275
#define COR 276
#define CAND 277
#define EQ 278
#define NEQ 279
#define LT 280
#define LE 281
#define GT 282
#define GE 283
#define CARETS 284
#define LOGNOT 285
#define STRING 286
#define LOOSE 287
#define ASSIGN 288
#define DIRTAG 289
#define JOIN_PREC 290
#define AND 291
#define ELLIPSIS 292
#define IMPORT 293
#define STRUCT 294
#define TYPEDEF 295
#define NEW 296
#define IF 297
#define ELSE 298
#define WHILE 299
#define DO 300
#define FOR 301
#define BREAK 302
#define CONTINUE 303
#define RETURN_ 304
#define STATIC 305
#define PUBLIC_TOK 306
#define PRIVATE_TOK 307
#define THIS 308
#define EXPLICIT 309
#define LIT 310
#define UNARY 311




/* Copy the first part of user declarations.  */
#line 1 "camp.y"

/*****
 * camp.y
 * Andy Hammerlindl 08/12/2002
 *
 * The grammar of the camp language.
 *****/

#include "errormsg.h"
#include "exp.h"
#include "newexp.h"
#include "stm.h"

// Avoid error messages with unpatched bison-1.875:
#ifndef __attribute__
#define __attribute__(x)
#endif

// Used when a position needs to be determined and no token is
// available.  Defined in camp.l.
position lexerPos();

int yylex(void); /* function prototype */

void yyerror(const char *s)
{
  em->error(lexerPos());
  *em << s;
  em->sync();
}

namespace absyntax { file *root; }

using namespace absyntax;
using sym::symbol;


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 38 "camp.y"
typedef union YYSTYPE {
  position pos;
  //sym::symbol *sym;
  struct {
    position pos;
    sym::symbol *sym;
  } ps;
  absyntax::name *n;
  absyntax::varinit *vi;
  absyntax::arrayinit *ai;
  absyntax::exp *e;
  absyntax::specExp *se;
  absyntax::joinExp *j;
  absyntax::explist *elist;
  absyntax::argument arg;
  absyntax::arglist *alist;
  absyntax::dimensions *dim;
  absyntax::ty  *t;
  absyntax::decid *di;
  absyntax::decidlist *dil;
  absyntax::decidstart *dis;
  absyntax::runnable *run;
  absyntax::modifierList *ml;
  struct {
    position pos;
    int keyword;
  } mod;
  //absyntax::program *prog;
  absyntax::vardec *vd;
  //absyntax::vardecs *vds;
  absyntax::dec *d;
  absyntax::stm *s;
  absyntax::blockStm *bs;
  absyntax::stmExpList *sel;
  //absyntax::funheader *fh;
  absyntax::formal *fl;
  absyntax::formals *fls;
  absyntax::file *fil;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 265 "camp.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 277 "camp.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) { /* empty */; }
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  else
#   define YYSIZE_T unsigned long int
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__)
#   if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#   endif
#  endif
# endif
# ifndef YYCOPY
#   define YYCOPY(To, From, Count)		\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1805

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  74
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  43
/* YYNRULES -- Number of rules. */
#define YYNRULES  174
/* YYNRULES -- Number of states. */
#define YYNSTATES  328

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   311

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    34,     2,     2,
      47,    48,    32,    29,    50,    31,    49,    33,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    41,    53,
       2,     2,     2,    39,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    51,     2,    52,    35,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    44,     2,    46,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    30,    36,    37,    38,    40,    42,
      43,    45,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     6,     9,    10,    13,    15,    19,
      23,    25,    27,    30,    33,    35,    38,    40,    42,    44,
      46,    48,    50,    54,    58,    61,    64,    66,    69,    71,
      74,    78,    82,    87,    89,    93,    95,    99,   101,   104,
     108,   113,   115,   117,   121,   124,   129,   133,   139,   141,
     143,   146,   148,   152,   154,   158,   161,   163,   167,   169,
     172,   177,   180,   184,   190,   196,   203,   210,   214,   217,
     221,   226,   231,   235,   240,   244,   249,   253,   255,   257,
     261,   263,   267,   270,   272,   276,   278,   280,   282,   284,
     287,   292,   298,   301,   304,   307,   311,   315,   319,   323,
     327,   331,   335,   339,   343,   347,   351,   355,   359,   363,
     367,   371,   374,   378,   383,   387,   392,   398,   405,   412,
     420,   426,   430,   436,   444,   448,   452,   455,   458,   461,
     464,   468,   472,   476,   480,   484,   488,   490,   492,   495,
     498,   502,   507,   511,   517,   519,   523,   527,   529,   531,
     534,   539,   543,   549,   552,   557,   559,   561,   564,   570,
     578,   584,   592,   602,   605,   608,   611,   615,   617,   618,
     620,   622,   623,   625,   627
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      75,     0,    -1,    76,    -1,    -1,    76,    79,    -1,    -1,
      77,    79,    -1,     3,    -1,    78,    49,     3,    -1,    37,
      49,     3,    -1,    82,    -1,   112,    -1,    80,    82,    -1,
      80,    93,    -1,    81,    -1,    80,    81,    -1,    67,    -1,
      68,    -1,    69,    -1,    83,    -1,   100,    -1,   101,    -1,
      55,     3,    53,    -1,    55,    37,    53,    -1,    84,    53,
      -1,    85,    89,    -1,    86,    -1,    78,    87,    -1,    78,
      -1,    51,    52,    -1,    87,    51,    52,    -1,    51,   106,
      52,    -1,    88,    51,   106,    52,    -1,    90,    -1,    89,
      50,    90,    -1,    91,    -1,    91,    40,    92,    -1,     3,
      -1,     3,    87,    -1,     3,    47,    48,    -1,     3,    47,
      97,    48,    -1,   106,    -1,    94,    -1,    44,    77,    46,
      -1,    44,    46,    -1,    44,    54,    92,    46,    -1,    44,
      95,    46,    -1,    44,    95,    54,    92,    46,    -1,    50,
      -1,    96,    -1,    96,    50,    -1,    92,    -1,    96,    50,
      92,    -1,    98,    -1,    98,    54,    99,    -1,    54,    99,
      -1,    99,    -1,    98,    50,    99,    -1,    85,    -1,    85,
      91,    -1,    85,    91,    40,    92,    -1,    71,    85,    -1,
      71,    85,    91,    -1,    71,    85,    91,    40,    92,    -1,
      85,     3,    47,    48,    93,    -1,    85,     3,    47,    97,
      48,    93,    -1,    85,     4,    47,    97,    48,    93,    -1,
      56,     3,    93,    -1,    57,    83,    -1,   102,    49,     3,
      -1,    78,    51,   106,    52,    -1,   102,    51,   106,    52,
      -1,    78,    47,    48,    -1,    78,    47,   104,    48,    -1,
     102,    47,    48,    -1,   102,    47,   104,    48,    -1,    47,
     106,    48,    -1,    70,    -1,   106,    -1,     3,    40,   106,
      -1,   105,    -1,   105,    54,   103,    -1,    54,   103,    -1,
     103,    -1,   105,    50,   103,    -1,    78,    -1,   102,    -1,
      72,    -1,    37,    -1,    72,   106,    -1,    47,    78,    48,
     106,    -1,    47,    78,    87,    48,   106,    -1,    29,   106,
      -1,    31,   106,    -1,    36,   106,    -1,   106,    29,   106,
      -1,   106,    31,   106,    -1,   106,    32,   106,    -1,   106,
      33,   106,    -1,   106,    34,   106,    -1,   106,    35,   106,
      -1,   106,    25,   106,    -1,   106,    26,   106,    -1,   106,
      27,   106,    -1,   106,    28,   106,    -1,   106,    23,   106,
      -1,   106,    24,   106,    -1,   106,    22,   106,    -1,   106,
      21,   106,    -1,   106,    30,   106,    -1,   106,    15,   106,
      -1,    58,    86,    -1,    58,    86,    88,    -1,    58,    86,
      88,    87,    -1,    58,    86,    87,    -1,    58,    86,    87,
      94,    -1,    58,    86,    47,    48,    93,    -1,    58,    86,
      87,    47,    48,    93,    -1,    58,    86,    47,    97,    48,
      93,    -1,    58,    86,    87,    47,    97,    48,    93,    -1,
     106,    39,   106,    41,   106,    -1,   106,    40,   106,    -1,
      47,   106,    50,   106,    48,    -1,    47,   106,    50,   106,
      50,   106,    48,    -1,   106,   107,   106,    -1,   106,   107,
      20,    -1,   106,   108,    -1,    15,   106,    -1,    13,   106,
      -1,   106,    15,    -1,   106,     5,   106,    -1,   106,     6,
     106,    -1,   106,     7,   106,    -1,   106,     8,   106,    -1,
     106,     9,   106,    -1,   106,    10,   106,    -1,    13,    -1,
     109,    -1,   108,   109,    -1,   109,   108,    -1,   108,   109,
     108,    -1,    44,    19,   106,    46,    -1,    44,   106,    46,
      -1,    44,   106,    50,   106,    46,    -1,    11,    -1,    11,
     110,    11,    -1,    11,   111,    11,    -1,    12,    -1,    14,
      -1,    17,   106,    -1,    17,   106,    45,   106,    -1,    17,
      18,   106,    -1,    17,    18,   106,    45,   106,    -1,    16,
     106,    -1,    16,   106,    45,   106,    -1,    53,    -1,    93,
      -1,   113,    53,    -1,    59,    47,   106,    48,   112,    -1,
      59,    47,   106,    48,   112,    60,   112,    -1,    61,    47,
     106,    48,   112,    -1,    62,   112,    61,    47,   106,    48,
      53,    -1,    63,    47,   114,    53,   106,    53,   115,    48,
     112,    -1,    64,    53,    -1,    65,    53,    -1,    66,    53,
      -1,    66,   106,    53,    -1,   106,    -1,    -1,   116,    -1,
      84,    -1,    -1,   116,    -1,   113,    -1,   116,    50,   113,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   154,   154,   158,   159,   164,   165,   175,   176,   177,
     187,   188,   189,   191,   196,   197,   202,   203,   204,   208,
     209,   210,   211,   212,   216,   220,   224,   229,   233,   239,
     240,   244,   245,   250,   251,   256,   257,   262,   263,   264,
     266,   271,   272,   276,   281,   282,   284,   286,   291,   292,
     293,   297,   299,   304,   305,   307,   311,   312,   317,   318,
     319,   321,   323,   325,   330,   332,   334,   339,   340,   345,
     346,   348,   349,   352,   356,   357,   360,   362,   366,   367,
     371,   372,   374,   378,   379,   392,   393,   394,   395,   397,
     401,   405,   407,   409,   411,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   425,   426,
     427,   428,   434,   436,   438,   440,   442,   444,   449,   451,
     456,   458,   460,   462,   464,   466,   470,   476,   478,   481,
     483,   484,   486,   487,   488,   489,   496,   497,   499,   502,
     505,   511,   512,   513,   519,   520,   522,   524,   525,   529,
     531,   534,   537,   543,   544,   549,   550,   551,   552,   554,
     556,   558,   560,   562,   563,   564,   565,   569,   573,   574,
     575,   579,   580,   584,   585
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ID", "OP", "ADD", "SUBTRACT", "TIMES",
  "DIVIDE", "MOD", "EXPONENT", "DOTS", "COLONS", "DASHES", "LONGDASH",
  "INCR", "CONTROLS", "TENSION", "ATLEAST", "CURL", "CYCLE", "COR", "CAND",
  "EQ", "NEQ", "LT", "LE", "GT", "GE", "'+'", "CARETS", "'-'", "'*'",
  "'/'", "'%'", "'^'", "LOGNOT", "STRING", "LOOSE", "'?'", "ASSIGN", "':'",
  "DIRTAG", "JOIN_PREC", "'{'", "AND", "'}'", "'('", "')'", "'.'", "','",
  "'['", "']'", "';'", "ELLIPSIS", "IMPORT", "STRUCT", "TYPEDEF", "NEW",
  "IF", "ELSE", "WHILE", "DO", "FOR", "BREAK", "CONTINUE", "RETURN_",
  "STATIC", "PUBLIC_TOK", "PRIVATE_TOK", "THIS", "EXPLICIT", "LIT",
  "UNARY", "$accept", "file", "fileblock", "bareblock", "name", "runnable",
  "modifiers", "modifier", "dec", "vardec", "barevardec", "type",
  "celltype", "dims", "dimexps", "decidlist", "decid", "decidstart",
  "varinit", "block", "arrayinit", "basearrayinit", "varinits", "formals",
  "baseformals", "formal", "fundec", "typedec", "value", "argument",
  "arglist", "basearglist", "exp", "join", "dir", "basicjoin", "tension",
  "controls", "stm", "stmexp", "forinit", "forupdate", "stmexplist", 0
};
#endif

/* INFRINGES ON USER NAME SPACE */
#ifndef _
# define _(msgid) msgid
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,    43,
     284,    45,    42,    47,    37,    94,   285,   286,   287,    63,
     288,    58,   289,   290,   123,   291,   125,    40,    41,    46,
      44,    91,    93,    59,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    74,    75,    76,    76,    77,    77,    78,    78,    78,
      79,    79,    79,    79,    80,    80,    81,    81,    81,    82,
      82,    82,    82,    82,    83,    84,    85,    85,    86,    87,
      87,    88,    88,    89,    89,    90,    90,    91,    91,    91,
      91,    92,    92,    93,    94,    94,    94,    94,    95,    95,
      95,    96,    96,    97,    97,    97,    98,    98,    99,    99,
      99,    99,    99,    99,   100,   100,   100,   101,   101,   102,
     102,   102,   102,   102,   102,   102,   102,   102,   103,   103,
     104,   104,   104,   105,   105,   106,   106,   106,   106,   106,
     106,   106,   106,   106,   106,   106,   106,   106,   106,   106,
     106,   106,   106,   106,   106,   106,   106,   106,   106,   106,
     106,   106,   106,   106,   106,   106,   106,   106,   106,   106,
     106,   106,   106,   106,   106,   106,   106,   106,   106,   106,
     106,   106,   106,   106,   106,   106,   107,   107,   107,   107,
     107,   108,   108,   108,   109,   109,   109,   109,   109,   110,
     110,   110,   110,   111,   111,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   113,   114,   114,
     114,   115,   115,   116,   116
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     0,     2,     0,     2,     1,     3,     3,
       1,     1,     2,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     3,     3,     2,     2,     1,     2,     1,     2,
       3,     3,     4,     1,     3,     1,     3,     1,     2,     3,
       4,     1,     1,     3,     2,     4,     3,     5,     1,     1,
       2,     1,     3,     1,     3,     2,     1,     3,     1,     2,
       4,     2,     3,     5,     5,     6,     6,     3,     2,     3,
       4,     4,     3,     4,     3,     4,     3,     1,     1,     3,
       1,     3,     2,     1,     3,     1,     1,     1,     1,     2,
       4,     5,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     4,     3,     4,     5,     6,     6,     7,
       5,     3,     5,     7,     3,     3,     2,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     1,     1,     2,     2,
       3,     4,     3,     5,     1,     3,     3,     1,     1,     2,
       4,     3,     5,     2,     4,     1,     1,     2,     5,     7,
       5,     7,     9,     2,     2,     2,     3,     1,     0,     1,
       1,     0,     1,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       3,     0,     2,     1,     7,     0,     0,     0,     0,     0,
      88,     5,     0,   155,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    16,    17,    18,    77,    87,
      85,     4,     0,    14,    10,    19,     0,     0,    26,   156,
      20,    21,    86,   167,    11,     0,    85,   128,   127,    92,
      93,    94,     0,     0,    85,     0,     0,     0,     0,     0,
      28,    68,     0,    28,   111,     0,     0,     0,   168,   163,
     164,   165,     0,    89,     0,     0,     0,    27,    15,    12,
      13,    24,    37,     0,    25,    33,    35,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   144,   147,   136,   148,
     129,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     126,   137,   157,     0,     9,    43,     6,     0,     0,    76,
       0,    22,    23,    67,     0,    37,     0,     0,   114,   112,
       0,     0,     0,   170,   173,     0,   169,   166,     7,    72,
       0,    83,     0,    80,    78,     8,    29,     0,     0,     0,
      38,     0,     0,     0,    74,     0,    69,     0,   130,   131,
     132,   133,   134,   135,     0,     0,     0,     0,   110,   108,
     107,   105,   106,   101,   102,   103,   104,    95,   109,    96,
      97,    98,    99,   100,     0,   121,     0,     0,   125,   124,
     138,   139,    90,     0,     0,     0,     0,     0,     0,    58,
       0,    53,    56,     0,     0,     0,   115,     0,   113,     0,
       0,     0,     0,     0,     0,    82,    73,     0,     0,    70,
      30,    39,     0,     0,    34,    36,    42,    41,    75,    71,
     153,     0,   149,   145,   146,     0,     0,   142,     0,   140,
      91,   122,     0,    39,     0,   116,    55,    61,    59,     0,
       0,     0,    31,    44,    48,     0,    51,     0,    49,     0,
       0,     0,   158,   160,     0,     0,   174,    79,    84,    81,
      64,    40,     0,     0,   151,     0,   120,   141,     0,     0,
      40,    62,     0,   118,    57,    54,     0,    46,     0,    50,
     117,     0,    32,     0,     0,   171,    65,    66,   154,     0,
     150,   143,   123,     0,    60,    45,     0,    52,   119,   159,
     161,     0,   172,   152,    63,    47,     0,   162
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     1,     2,    53,    46,    31,    32,    33,    34,    35,
      36,   209,    38,    77,   139,    84,    85,    86,   235,    39,
     236,   267,   268,   210,   211,   212,    40,    41,    42,   151,
     152,   153,    43,   119,   120,   121,   176,   177,    44,    45,
     145,   321,   146
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -204
static const short int yypact[] =
{
    -204,    16,   334,  -204,  -204,   618,   618,   618,   618,   618,
     -28,  -204,   618,  -204,    11,    25,    14,    14,   -20,    -6,
     131,    18,    22,    27,   462,  -204,  -204,  -204,  -204,   212,
     132,  -204,   637,  -204,  -204,  -204,    30,    59,  -204,  -204,
    -204,  -204,    21,  1553,  -204,    41,    91,    23,    23,    23,
      23,  -204,   116,   266,    82,   992,    75,    84,    95,   -28,
       1,  -204,   140,    98,   -29,   618,   618,    94,   618,  -204,
    -204,  -204,   702,    23,   422,   154,   492,   105,  -204,  -204,
    -204,  -204,   -14,   112,   111,  -204,   125,   442,   163,   618,
     618,   618,   618,   618,   618,   618,   107,  -204,  -204,  -204,
     212,   618,   618,   618,   618,   618,   618,   618,   618,   618,
     618,   618,   618,   618,   618,   618,   618,   618,   522,   552,
    -204,   127,  -204,   618,  -204,  -204,  -204,   618,    28,  -204,
     618,  -204,  -204,  -204,   121,    -4,   196,   492,   -12,   126,
    1130,  1174,   129,  -204,  -204,   149,   130,  -204,   166,  -204,
     631,  -204,   160,    -1,  1553,  -204,  -204,   800,   158,   235,
     105,   197,   140,   571,  -204,   165,  -204,   848,  1553,  1553,
    1553,  1553,  1553,  1553,   618,   601,   200,   203,   119,  1661,
    1686,  1711,  1711,  1736,  1736,  1736,  1736,   153,  1761,   153,
      23,    23,    23,    23,  1513,  1553,   618,  1038,  -204,   119,
     127,  -204,    23,   618,  1084,   238,    95,     7,    14,   140,
     176,     5,  -204,   896,   402,   302,  -204,   492,   105,   131,
     131,   618,   618,   618,   618,  -204,  -204,   631,   631,  -204,
    -204,    95,   177,   178,  -204,  -204,  -204,  1553,  -204,  -204,
    1390,   618,  1431,  -204,  -204,   618,  1306,  -204,   618,  -204,
      23,  -204,   618,  -204,   179,  -204,  -204,   140,   189,    95,
       7,     7,  -204,  -204,  -204,   571,  -204,   -23,   180,    95,
     183,   944,   182,  -204,  1218,   751,  -204,  1553,  -204,  -204,
    -204,    95,    95,   618,  1472,   618,  1627,  -204,  1348,  1262,
    -204,   199,   571,  -204,  -204,  -204,   191,  -204,   571,   571,
    -204,    95,  -204,   131,   201,   618,  -204,  -204,  1593,   618,
    1593,  -204,  -204,   571,  -204,  -204,   206,  -204,  -204,  -204,
    -204,   205,   130,  1593,  -204,  -204,   131,  -204
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -204,  -204,  -204,  -204,    13,   202,  -204,   224,   229,   246,
     195,    24,   247,   -18,  -204,  -204,   103,  -203,  -172,   -24,
     128,  -204,  -204,  -148,  -204,  -187,  -204,  -204,  -204,  -112,
     184,  -204,    -5,  -204,  -109,   156,  -204,  -204,   -15,   -59,
    -204,  -204,    -9
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -29
static const short int yytable[] =
{
      47,    48,    49,    50,    51,    67,   258,    55,    80,   144,
       4,   232,   201,   233,    56,    30,     3,     4,   136,    72,
     256,    52,   137,   297,    73,    54,    37,    65,    58,    60,
      63,   298,   214,   159,   133,   215,   128,   134,   225,   158,
      62,    66,   266,   205,    59,    60,   138,   134,    57,   227,
      75,    59,   134,   228,   291,   260,    37,   254,   115,   261,
     140,   141,    82,    83,   160,    68,    30,   270,    87,   154,
      88,   157,    89,   294,   295,    69,   203,    37,   208,   158,
      70,    30,   154,    81,   167,   168,   169,   170,   171,   172,
     173,   249,    62,   296,   122,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   197,   199,   278,   279,   160,   157,   124,
     314,   218,   202,   174,   175,   204,   316,   317,   131,    74,
     127,    75,   213,    76,     4,   -28,   -28,   132,    74,    11,
      75,   324,   123,   135,     5,   154,     6,    75,   109,    60,
     111,   112,   113,   114,   115,   142,   158,   155,   237,   161,
       7,   162,     8,   118,   276,   163,   166,     9,    10,   240,
     242,   118,    60,   156,    60,    11,   221,   217,    12,    74,
     223,    75,   255,    76,    13,   112,   113,   114,   115,    17,
      18,   246,    19,    20,    21,    22,    23,    24,   250,     4,
       4,    28,   222,    29,   272,   273,   224,   280,   226,   237,
     230,   243,   271,   238,   244,     4,   274,   275,    60,   277,
      60,    60,   154,   154,   259,   281,   282,   290,    60,   292,
     299,   301,   257,    59,    59,   293,   284,   315,     4,   313,
     286,     4,   303,   288,   206,   300,   144,   289,     9,    10,
     207,   207,   325,   326,   320,   126,    78,   306,   307,    12,
     237,    79,    61,   143,    64,   234,   216,   208,   208,     4,
      17,   165,    59,    60,    60,    59,   200,   318,   308,     5,
     310,     6,    28,   231,    29,     0,   253,   237,   319,   207,
       0,     0,   207,   237,   237,     7,   322,     8,     0,     0,
       0,     0,     9,    10,   323,     4,   208,     0,   237,   208,
      11,   327,   125,    12,     0,     0,     0,     0,     0,    13,
       0,    14,    15,    16,    17,    18,     0,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,     4,    29,    59,
       0,     0,     0,     0,     0,     0,     0,     5,     0,     6,
     269,     0,     0,     0,     0,     0,   207,     0,     0,     0,
       0,     0,     0,     7,     0,     8,     0,     0,     0,     0,
       9,    10,     0,   208,     0,     0,     0,     0,    11,     0,
       0,    12,     0,     0,     0,     0,     0,    13,     0,    14,
      15,    16,    17,    18,     0,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,     4,    29,     0,     0,     0,
       0,     0,     0,     0,     0,     5,     0,     6,     0,     0,
       0,     0,     0,     0,     0,   148,     0,     0,     0,     0,
       0,     7,     0,     8,     0,     5,     0,     6,     9,    10,
       0,     0,     0,     0,     0,   148,   214,     0,   263,    12,
       0,     7,   264,     8,     0,     5,   265,     6,     9,    10,
      17,     0,     0,     0,     0,     4,     0,     0,     0,    12,
     149,     7,    28,     8,    29,     5,   150,     6,     9,    10,
      17,     0,     0,     0,     0,     0,     0,     0,     0,    12,
     164,     7,    28,     8,    29,     4,   150,     0,     9,    10,
      17,     0,     0,     0,     0,     5,     0,     6,     0,    12,
       0,     0,    28,     0,    29,    71,     0,     0,     0,     0,
      17,     7,     0,     8,     0,     4,     0,     0,     9,    10,
       0,     0,    28,     0,    29,     5,     0,     6,     0,    12,
       0,   196,     0,     0,   156,     0,     0,     0,     0,     0,
      17,     7,     0,     8,     0,     4,     0,     0,     9,    10,
       0,     0,    28,     0,    29,     5,     0,     6,     0,    12,
       0,     0,   198,     0,     4,     0,     0,     0,     0,     0,
      17,     7,     0,     8,     5,     0,     6,     0,     9,    10,
       0,     0,    28,     0,    29,     0,     0,     0,     0,    12,
       7,     0,     8,     0,     4,     0,     0,     9,    10,     0,
      17,     0,     0,     0,     5,   214,     6,     0,    12,   241,
       0,     4,    28,     0,    29,     0,     0,     0,     0,    17,
       7,     5,     8,     6,   148,     0,     0,     9,    10,     0,
       4,    28,     0,    29,     5,     0,     6,     7,    12,     8,
       0,     0,     0,     0,     9,    10,     0,     0,     0,    17,
       7,     0,     8,     0,     0,    12,     0,     9,    10,     0,
       0,    28,     0,    29,    59,     0,    17,     0,    12,     0,
       0,    11,     0,     0,     0,     0,     0,     0,    28,    17,
      29,     0,    14,    15,    16,     0,     0,     0,     0,     0,
       0,    28,     0,    29,    25,    26,    27,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,     0,     0,
       0,     0,     0,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,     0,     0,
       0,   116,   117,     0,     0,     0,   118,     0,     0,     0,
       0,     0,     0,     0,     0,   147,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,     0,     0,     0,
       0,     0,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,     0,     0,     0,
     116,   117,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,   305,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,     0,     0,     0,     0,
       0,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,     0,     0,     0,   116,
     117,     0,     0,     0,   118,     0,     0,     0,     0,     0,
       0,     0,   229,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,     0,     0,     0,     0,     0,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,     0,     0,     0,   116,   117,     0,
       0,     0,   118,     0,     0,     0,     0,     0,     0,     0,
     239,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,     0,     0,     0,     0,     0,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,     0,     0,     0,   116,   117,     0,     0,     0,
     118,     0,     0,     0,     0,     0,     0,     0,   262,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
       0,     0,     0,     0,     0,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
       0,     0,     0,   116,   117,     0,     0,     0,   118,     0,
       0,     0,     0,     0,     0,     0,   302,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,     0,     0,
       0,     0,     0,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,     0,     0,
       0,   116,   117,     0,     0,     0,   118,     0,     0,     0,
     129,     0,   130,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,     0,     0,     0,     0,     0,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,     0,     0,     0,   116,   117,     0,
       0,     0,   118,     0,   247,     0,     0,     0,   248,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
       0,     0,     0,     0,     0,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
       0,     0,     0,   116,   117,     0,     0,     0,   118,     0,
       0,     0,   251,     0,   252,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,     0,     0,     0,     0,
       0,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,     0,     0,     0,   116,
     117,     0,     0,     0,   118,     0,     0,     0,   219,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
       0,     0,     0,     0,     0,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
       0,     0,     0,   116,   117,     0,     0,     0,   118,     0,
       0,     0,   220,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,     0,     0,     0,     0,     0,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,     0,     0,     0,   116,   117,     0,
       0,     0,   118,     0,     0,     0,   304,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,     0,     0,
       0,     0,     0,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,     0,     0,
       0,   116,   117,     0,     0,     0,   118,     0,     0,     0,
     312,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,     0,     0,     0,     0,     0,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,     0,     0,     0,   116,   117,     0,     0,     0,
     118,     0,   287,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,     0,     0,     0,     0,     0,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,     0,     0,     0,   116,   117,     0,
       0,     0,   118,     0,   311,    90,    91,    92,    93,    94,
      95,     0,    97,    98,    99,   100,     0,     0,     0,     0,
       0,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,     0,     0,     0,   116,
     117,     0,     0,     0,   118,   283,    90,    91,    92,    93,
      94,    95,     0,    97,    98,    99,   100,     0,     0,     0,
       0,     0,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,     0,     0,     0,
     116,   117,     0,     0,     0,   118,   285,    90,    91,    92,
      93,    94,    95,     0,    97,    98,    99,   100,     0,     0,
       0,     0,     0,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,     0,     0,
       0,   116,   117,     0,     0,     0,   118,   309,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,     0,
       0,     0,     0,     0,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,     0,
       0,     0,   116,   117,   245,     0,     0,   118,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,     0,
       0,     0,     0,     0,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,     0,
       0,     0,   116,   117,     0,     0,     0,   118,    90,    91,
      92,    93,    94,    95,     0,    97,    98,    99,   100,     0,
       0,     0,     0,     0,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,     0,
       0,     0,   116,   117,     0,     0,     0,   118,    96,    97,
      98,    99,   100,     0,     0,     0,     0,     0,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,     0,     0,     0,   116,     0,     0,     0,
       0,   118,    96,    97,    98,    99,   100,     0,     0,     0,
       0,     0,     0,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,    96,    97,    98,
      99,   100,     0,     0,     0,   118,     0,     0,     0,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,    96,    97,    98,    99,   100,     0,     0,     0,
     118,     0,     0,     0,     0,     0,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,    96,    97,    98,
      99,   100,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   109,   110,   111,   112,   113,
     114,   115,    96,    97,    98,    99,   100,     0,     0,     0,
     118,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     109,     0,   111,   112,   113,   114,   115,     0,     0,     0,
       0,     0,     0,     0,     0,   118
};

static const short int yycheck[] =
{
       5,     6,     7,     8,     9,    20,   209,    12,    32,    68,
       3,   159,   121,   161,     3,     2,     0,     3,    47,    24,
     207,    49,    51,    46,    29,    12,     2,    47,     3,    16,
      17,    54,    44,    47,    58,    47,    54,    51,   150,    51,
      16,    47,   214,    47,    37,    32,    64,    51,    37,    50,
      49,    37,    51,    54,   257,    50,    32,   205,    35,    54,
      65,    66,     3,     4,    82,    47,    53,   215,    47,    74,
      49,    76,    51,   260,   261,    53,    48,    53,    71,    51,
      53,    68,    87,    53,    89,    90,    91,    92,    93,    94,
      95,   200,    68,   265,    53,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   227,   228,   135,   123,     3,
     292,   139,   127,    16,    17,   130,   298,   299,    53,    47,
      48,    49,   137,    51,     3,     3,     4,    53,    47,    44,
      49,   313,    51,     3,    13,   150,    15,    49,    29,   136,
      31,    32,    33,    34,    35,    61,    51,     3,   163,    47,
      29,    50,    31,    44,   223,    40,     3,    36,    37,   174,
     175,    44,   159,    52,   161,    44,    47,    51,    47,    47,
      50,    49,   206,    51,    53,    32,    33,    34,    35,    58,
      59,   196,    61,    62,    63,    64,    65,    66,   203,     3,
       3,    70,    53,    72,   219,   220,    40,   231,    48,   214,
      52,    11,   217,    48,    11,     3,   221,   222,   205,   224,
     207,   208,   227,   228,    48,    48,    48,    48,   215,    40,
      50,    48,   208,    37,    37,   259,   241,    46,     3,    40,
     245,     3,    60,   248,    48,   269,   305,   252,    36,    37,
      54,    54,    46,    48,    53,    53,    32,   281,   282,    47,
     265,    32,    16,    68,    17,   162,   138,    71,    71,     3,
      58,    87,    37,   260,   261,    37,   120,   301,   283,    13,
     285,    15,    70,    48,    72,    -1,    48,   292,   303,    54,
      -1,    -1,    54,   298,   299,    29,   305,    31,    -1,    -1,
      -1,    -1,    36,    37,   309,     3,    71,    -1,   313,    71,
      44,   326,    46,    47,    -1,    -1,    -1,    -1,    -1,    53,
      -1,    55,    56,    57,    58,    59,    -1,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,     3,    72,    37,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    13,    -1,    15,
      48,    -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,
      -1,    -1,    -1,    29,    -1,    31,    -1,    -1,    -1,    -1,
      36,    37,    -1,    71,    -1,    -1,    -1,    -1,    44,    -1,
      -1,    47,    -1,    -1,    -1,    -1,    -1,    53,    -1,    55,
      56,    57,    58,    59,    -1,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,     3,    72,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    13,    -1,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    29,    -1,    31,    -1,    13,    -1,    15,    36,    37,
      -1,    -1,    -1,    -1,    -1,     3,    44,    -1,    46,    47,
      -1,    29,    50,    31,    -1,    13,    54,    15,    36,    37,
      58,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    47,
      48,    29,    70,    31,    72,    13,    54,    15,    36,    37,
      58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,
      48,    29,    70,    31,    72,     3,    54,    -1,    36,    37,
      58,    -1,    -1,    -1,    -1,    13,    -1,    15,    -1,    47,
      -1,    -1,    70,    -1,    72,    53,    -1,    -1,    -1,    -1,
      58,    29,    -1,    31,    -1,     3,    -1,    -1,    36,    37,
      -1,    -1,    70,    -1,    72,    13,    -1,    15,    -1,    47,
      -1,    19,    -1,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      58,    29,    -1,    31,    -1,     3,    -1,    -1,    36,    37,
      -1,    -1,    70,    -1,    72,    13,    -1,    15,    -1,    47,
      -1,    -1,    20,    -1,     3,    -1,    -1,    -1,    -1,    -1,
      58,    29,    -1,    31,    13,    -1,    15,    -1,    36,    37,
      -1,    -1,    70,    -1,    72,    -1,    -1,    -1,    -1,    47,
      29,    -1,    31,    -1,     3,    -1,    -1,    36,    37,    -1,
      58,    -1,    -1,    -1,    13,    44,    15,    -1,    47,    18,
      -1,     3,    70,    -1,    72,    -1,    -1,    -1,    -1,    58,
      29,    13,    31,    15,     3,    -1,    -1,    36,    37,    -1,
       3,    70,    -1,    72,    13,    -1,    15,    29,    47,    31,
      -1,    -1,    -1,    -1,    36,    37,    -1,    -1,    -1,    58,
      29,    -1,    31,    -1,    -1,    47,    -1,    36,    37,    -1,
      -1,    70,    -1,    72,    37,    -1,    58,    -1,    47,    -1,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    70,    58,
      72,    -1,    55,    56,    57,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    72,    67,    68,    69,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    39,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    53,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      39,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    53,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    39,
      40,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    52,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    39,    40,    -1,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      52,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    39,    40,    -1,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    39,    40,    -1,    -1,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    52,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    39,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    39,    40,    -1,
      -1,    -1,    44,    -1,    46,    -1,    -1,    -1,    50,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    39,    40,    -1,    -1,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    39,
      40,    -1,    -1,    -1,    44,    -1,    -1,    -1,    48,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    39,    40,    -1,    -1,    -1,    44,    -1,
      -1,    -1,    48,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    39,    40,    -1,
      -1,    -1,    44,    -1,    -1,    -1,    48,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    39,    40,    -1,    -1,    -1,    44,    -1,    -1,    -1,
      48,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    39,    40,    -1,    -1,    -1,
      44,    -1,    46,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    39,    40,    -1,
      -1,    -1,    44,    -1,    46,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    39,
      40,    -1,    -1,    -1,    44,    45,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      39,    40,    -1,    -1,    -1,    44,    45,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    39,    40,    -1,    -1,    -1,    44,    45,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    39,    40,    41,    -1,    -1,    44,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    39,    40,    -1,    -1,    -1,    44,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      -1,    -1,    39,    40,    -1,    -1,    -1,    44,    11,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    44,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    44,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    11,    12,    13,
      14,    15,    -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,
      34,    35,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      29,    -1,    31,    32,    33,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    44
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    75,    76,     0,     3,    13,    15,    29,    31,    36,
      37,    44,    47,    53,    55,    56,    57,    58,    59,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    72,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    93,
     100,   101,   102,   106,   112,   113,    78,   106,   106,   106,
     106,   106,    49,    77,    78,   106,     3,    37,     3,    37,
      78,    83,    85,    78,    86,    47,    47,   112,    47,    53,
      53,    53,   106,   106,    47,    49,    51,    87,    81,    82,
      93,    53,     3,     4,    89,    90,    91,    47,    49,    51,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    39,    40,    44,   107,
     108,   109,    53,    51,     3,    46,    79,    48,    87,    48,
      50,    53,    53,    93,    51,     3,    47,    51,    87,    88,
     106,   106,    61,    84,   113,   114,   116,    53,     3,    48,
      54,   103,   104,   105,   106,     3,    52,   106,    51,    47,
      87,    47,    50,    40,    48,   104,     3,   106,   106,   106,
     106,   106,   106,   106,    16,    17,   110,   111,   106,   106,
     106,   106,   106,   106,   106,   106,   106,   106,   106,   106,
     106,   106,   106,   106,   106,   106,    19,   106,    20,   106,
     109,   108,   106,    48,   106,    47,    48,    54,    71,    85,
      97,    98,    99,   106,    44,    47,    94,    51,    87,    48,
      48,    47,    53,    50,    40,   103,    48,    50,    54,    52,
      52,    48,    97,    97,    90,    92,    94,   106,    48,    52,
     106,    18,   106,    11,    11,    41,   106,    46,    50,   108,
     106,    48,    50,    48,    97,    93,    99,    85,    91,    48,
      50,    54,    52,    46,    50,    54,    92,    95,    96,    48,
      97,   106,   112,   112,   106,   106,   113,   106,   103,   103,
      93,    48,    48,    45,   106,    45,   106,    46,   106,   106,
      48,    91,    40,    93,    99,    99,    92,    46,    54,    50,
      93,    48,    52,    60,    48,    53,    93,    93,   106,    45,
     106,    46,    48,    40,    92,    46,    92,    92,    93,   112,
      53,   115,   116,   106,    92,    46,    48,   112
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab
int yy_false=false; /* Used to suppress compiler warning about unused label */


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
{								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror (_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
}


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    {									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    }
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# ifdef YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
{						\
  if (yydebug)					\
    YYFPRINTF Args;				\
}

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
{								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, _("Stack now"));
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
{								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
}


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, _("Reducing stack by rule %d (line %u), "),
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
{					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
}

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen=0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  yyvsp[0] = yylval;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = (short int) yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (_("parser stack overflow"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, _("Stack size increased to %lu\n"),
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, _("Entering state %d\n"), yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, _("Reading a token: ")));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, _("Now at end of input.\n")));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT (_("Next token is"), yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT (_("Shifting"), yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 154 "camp.y"
    { absyntax::root = (yyvsp[0].fil); ;}
    break;

  case 3:
#line 158 "camp.y"
    { (yyval.fil) = new file(lexerPos()); ;}
    break;

  case 4:
#line 160 "camp.y"
    { (yyval.fil) = (yyvsp[-1].fil); (yyval.fil)->add((yyvsp[0].run)); ;}
    break;

  case 5:
#line 164 "camp.y"
    { (yyval.bs) = new blockStm(lexerPos()); ;}
    break;

  case 6:
#line 166 "camp.y"
    { (yyval.bs) = (yyvsp[-1].bs); (yyval.bs)->add((yyvsp[0].run)); ;}
    break;

  case 7:
#line 175 "camp.y"
    { (yyval.n) = new simpleName((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 8:
#line 176 "camp.y"
    { (yyval.n) = new qualifiedName((yyvsp[-1].pos), (yyvsp[-2].n), (yyvsp[0].ps).sym); ;}
    break;

  case 9:
#line 177 "camp.y"
    { (yyval.n) = new qualifiedName((yyvsp[-1].pos), new simpleName((yyvsp[-1].pos), (yyvsp[-2].ps).sym),
					    (yyvsp[0].ps).sym); ;}
    break;

  case 10:
#line 187 "camp.y"
    { (yyval.run) = (yyvsp[0].d); ;}
    break;

  case 11:
#line 188 "camp.y"
    { (yyval.run) = (yyvsp[0].s); ;}
    break;

  case 12:
#line 190 "camp.y"
    { (yyval.run) = new modifiedRunnable((yyvsp[-1].ml)->getPos(), (yyvsp[-1].ml), (yyvsp[0].d)); ;}
    break;

  case 13:
#line 192 "camp.y"
    { (yyval.run) = new modifiedRunnable((yyvsp[-1].ml)->getPos(), (yyvsp[-1].ml), (yyvsp[0].bs)); ;}
    break;

  case 14:
#line 196 "camp.y"
    { (yyval.ml) = new modifierList((yyvsp[0].mod).pos); (yyval.ml)->add((yyvsp[0].mod).keyword); ;}
    break;

  case 15:
#line 198 "camp.y"
    { (yyval.ml) = (yyvsp[-1].ml); (yyval.ml)->add((yyvsp[0].mod).keyword); ;}
    break;

  case 16:
#line 202 "camp.y"
    { (yyval.mod).pos = (yyvsp[0].pos); (yyval.mod).keyword = STATIC; ;}
    break;

  case 17:
#line 203 "camp.y"
    { (yyval.mod).pos = (yyvsp[0].pos); (yyval.mod).keyword = PUBLIC_TOK; ;}
    break;

  case 18:
#line 204 "camp.y"
    { (yyval.mod).pos = (yyvsp[0].pos); (yyval.mod).keyword = PRIVATE_TOK; ;}
    break;

  case 19:
#line 208 "camp.y"
    { (yyval.d) = (yyvsp[0].vd); ;}
    break;

  case 20:
#line 209 "camp.y"
    { (yyval.d) = (yyvsp[0].d); ;}
    break;

  case 21:
#line 210 "camp.y"
    { (yyval.d) = (yyvsp[0].d); ;}
    break;

  case 22:
#line 211 "camp.y"
    { (yyval.d) = new importdec((yyvsp[-2].pos), (yyvsp[-1].ps).sym); ;}
    break;

  case 23:
#line 212 "camp.y"
    { (yyval.d) = new importdec((yyvsp[-2].pos), (yyvsp[-1].ps).sym); ;}
    break;

  case 24:
#line 216 "camp.y"
    { (yyval.vd) = (yyvsp[-1].vd); ;}
    break;

  case 25:
#line 220 "camp.y"
    { (yyval.vd) = new vardec((yyvsp[-1].t)->getPos(), (yyvsp[-1].t), (yyvsp[0].dil)); ;}
    break;

  case 26:
#line 224 "camp.y"
    { (yyval.t) = (yyvsp[0].t); ;}
    break;

  case 27:
#line 229 "camp.y"
    { (yyval.t) = new arrayTy((yyvsp[-1].n), (yyvsp[0].dim)); ;}
    break;

  case 28:
#line 233 "camp.y"
    { (yyval.t) = new nameTy((yyvsp[0].n)); ;}
    break;

  case 29:
#line 239 "camp.y"
    { (yyval.dim) = new dimensions((yyvsp[-1].pos)); ;}
    break;

  case 30:
#line 240 "camp.y"
    { (yyval.dim) = (yyvsp[-2].dim); (yyval.dim)->increase(); ;}
    break;

  case 31:
#line 244 "camp.y"
    { (yyval.elist) = new explist((yyvsp[-2].pos)); (yyval.elist)->add((yyvsp[-1].e)); ;}
    break;

  case 32:
#line 246 "camp.y"
    { (yyval.elist) = (yyvsp[-3].elist); (yyval.elist)->add((yyvsp[-1].e)); ;}
    break;

  case 33:
#line 250 "camp.y"
    { (yyval.dil) = new decidlist((yyvsp[0].di)->getPos()); (yyval.dil)->add((yyvsp[0].di)); ;}
    break;

  case 34:
#line 252 "camp.y"
    { (yyval.dil) = (yyvsp[-2].dil); (yyval.dil)->add((yyvsp[0].di)); ;}
    break;

  case 35:
#line 256 "camp.y"
    { (yyval.di) = new decid((yyvsp[0].dis)->getPos(), (yyvsp[0].dis)); ;}
    break;

  case 36:
#line 258 "camp.y"
    { (yyval.di) = new decid((yyvsp[-2].dis)->getPos(), (yyvsp[-2].dis), (yyvsp[0].vi)); ;}
    break;

  case 37:
#line 262 "camp.y"
    { (yyval.dis) = new decidstart((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 38:
#line 263 "camp.y"
    { (yyval.dis) = new decidstart((yyvsp[-1].ps).pos, (yyvsp[-1].ps).sym, (yyvsp[0].dim)); ;}
    break;

  case 39:
#line 264 "camp.y"
    { (yyval.dis) = new fundecidstart((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym, 0,
                                            new formals((yyvsp[-1].pos))); ;}
    break;

  case 40:
#line 267 "camp.y"
    { (yyval.dis) = new fundecidstart((yyvsp[-3].ps).pos, (yyvsp[-3].ps).sym, 0, (yyvsp[-1].fls)); ;}
    break;

  case 41:
#line 271 "camp.y"
    { (yyval.vi) = (yyvsp[0].e); ;}
    break;

  case 42:
#line 272 "camp.y"
    { (yyval.vi) = (yyvsp[0].ai); ;}
    break;

  case 43:
#line 277 "camp.y"
    { (yyval.bs) = (yyvsp[-1].bs); ;}
    break;

  case 44:
#line 281 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[-1].pos)); ;}
    break;

  case 45:
#line 283 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[-3].pos)); (yyval.ai)->addRest((yyvsp[-1].vi)); ;}
    break;

  case 46:
#line 285 "camp.y"
    { (yyval.ai) = (yyvsp[-1].ai); ;}
    break;

  case 47:
#line 287 "camp.y"
    { (yyval.ai) = (yyvsp[-3].ai); (yyval.ai)->addRest((yyvsp[-1].vi)); ;}
    break;

  case 48:
#line 291 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[0].pos)); ;}
    break;

  case 49:
#line 292 "camp.y"
    { (yyval.ai) = (yyvsp[0].ai); ;}
    break;

  case 50:
#line 293 "camp.y"
    { (yyval.ai) = (yyvsp[-1].ai); ;}
    break;

  case 51:
#line 297 "camp.y"
    { (yyval.ai) = new arrayinit((yyvsp[0].vi)->getPos());
		     (yyval.ai)->add((yyvsp[0].vi));;}
    break;

  case 52:
#line 300 "camp.y"
    { (yyval.ai) = (yyvsp[-2].ai); (yyval.ai)->add((yyvsp[0].vi)); ;}
    break;

  case 53:
#line 304 "camp.y"
    { (yyval.fls) = (yyvsp[0].fls); ;}
    break;

  case 54:
#line 306 "camp.y"
    { (yyval.fls) = (yyvsp[-2].fls); (yyval.fls)->addRest((yyvsp[0].fl)); ;}
    break;

  case 55:
#line 307 "camp.y"
    { (yyval.fls) = new formals((yyvsp[-1].pos)); (yyval.fls)->addRest((yyvsp[0].fl)); ;}
    break;

  case 56:
#line 311 "camp.y"
    { (yyval.fls) = new formals((yyvsp[0].fl)->getPos()); (yyval.fls)->add((yyvsp[0].fl)); ;}
    break;

  case 57:
#line 313 "camp.y"
    { (yyval.fls) = (yyvsp[-2].fls); (yyval.fls)->add((yyvsp[0].fl)); ;}
    break;

  case 58:
#line 317 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].t)->getPos(), (yyvsp[0].t)); ;}
    break;

  case 59:
#line 318 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].dis)->getPos(), (yyvsp[-1].t), (yyvsp[0].dis)); ;}
    break;

  case 60:
#line 320 "camp.y"
    { (yyval.fl) = new formal((yyvsp[-2].dis)->getPos(), (yyvsp[-3].t), (yyvsp[-2].dis), (yyvsp[0].vi)); ;}
    break;

  case 61:
#line 322 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].t)->getPos(), (yyvsp[0].t), 0, 0, true); ;}
    break;

  case 62:
#line 324 "camp.y"
    { (yyval.fl) = new formal((yyvsp[0].dis)->getPos(), (yyvsp[-1].t), (yyvsp[0].dis), 0, true); ;}
    break;

  case 63:
#line 326 "camp.y"
    { (yyval.fl) = new formal((yyvsp[-2].dis)->getPos(), (yyvsp[-3].t), (yyvsp[-2].dis), (yyvsp[0].vi), true); ;}
    break;

  case 64:
#line 331 "camp.y"
    { (yyval.d) = new fundec((yyvsp[-2].pos), (yyvsp[-4].t), (yyvsp[-3].ps).sym, new formals((yyvsp[-2].pos)), (yyvsp[0].bs)); ;}
    break;

  case 65:
#line 333 "camp.y"
    { (yyval.d) = new fundec((yyvsp[-3].pos), (yyvsp[-5].t), (yyvsp[-4].ps).sym, (yyvsp[-2].fls), (yyvsp[0].bs)); ;}
    break;

  case 66:
#line 335 "camp.y"
    { (yyval.d) = new fundec((yyvsp[-3].pos), (yyvsp[-5].t), (yyvsp[-4].ps).sym, (yyvsp[-2].fls), (yyvsp[0].bs)); ;}
    break;

  case 67:
#line 339 "camp.y"
    { (yyval.d) = new recorddec((yyvsp[-2].pos), (yyvsp[-1].ps).sym, (yyvsp[0].bs)); ;}
    break;

  case 68:
#line 340 "camp.y"
    { (yyval.d) = new typedec((yyvsp[-1].pos), (yyvsp[0].vd)); ;}
    break;

  case 69:
#line 345 "camp.y"
    { (yyval.e) = new fieldExp((yyvsp[-1].pos), (yyvsp[-2].e), (yyvsp[0].ps).sym); ;}
    break;

  case 70:
#line 346 "camp.y"
    { (yyval.e) = new subscriptExp((yyvsp[-2].pos),
                              new nameExp((yyvsp[-3].n)->getPos(), (yyvsp[-3].n)), (yyvsp[-1].e)); ;}
    break;

  case 71:
#line 348 "camp.y"
    { (yyval.e) = new subscriptExp((yyvsp[-2].pos), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 72:
#line 349 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-1].pos),
                                      new nameExp((yyvsp[-2].n)->getPos(), (yyvsp[-2].n)),
                                      new arglist()); ;}
    break;

  case 73:
#line 353 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-2].pos), 
                                      new nameExp((yyvsp[-3].n)->getPos(), (yyvsp[-3].n)),
                                      (yyvsp[-1].alist)); ;}
    break;

  case 74:
#line 356 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-1].pos), (yyvsp[-2].e), new arglist()); ;}
    break;

  case 75:
#line 358 "camp.y"
    { (yyval.e) = new callExp((yyvsp[-2].pos), (yyvsp[-3].e), (yyvsp[-1].alist)); ;}
    break;

  case 76:
#line 361 "camp.y"
    { (yyval.e) = (yyvsp[-1].e); ;}
    break;

  case 77:
#line 362 "camp.y"
    { (yyval.e) = new thisExp((yyvsp[0].pos)); ;}
    break;

  case 78:
#line 366 "camp.y"
    { (yyval.arg).name=0;      (yyval.arg).val=(yyvsp[0].e); ;}
    break;

  case 79:
#line 367 "camp.y"
    { (yyval.arg).name=(yyvsp[-2].ps).sym; (yyval.arg).val=(yyvsp[0].e); ;}
    break;

  case 80:
#line 371 "camp.y"
    { (yyval.alist) = (yyvsp[0].alist); ;}
    break;

  case 81:
#line 373 "camp.y"
    { (yyval.alist) = (yyvsp[-2].alist); (yyval.alist)->rest = (yyvsp[0].arg); ;}
    break;

  case 82:
#line 374 "camp.y"
    { (yyval.alist) = new arglist(); (yyval.alist)->rest = (yyvsp[0].arg); ;}
    break;

  case 83:
#line 378 "camp.y"
    { (yyval.alist) = new arglist(); (yyval.alist)->add((yyvsp[0].arg)); ;}
    break;

  case 84:
#line 380 "camp.y"
    { (yyval.alist) = (yyvsp[-2].alist); (yyval.alist)->add((yyvsp[0].arg)); ;}
    break;

  case 85:
#line 392 "camp.y"
    { (yyval.e) = new nameExp((yyvsp[0].n)->getPos(), (yyvsp[0].n)); ;}
    break;

  case 86:
#line 393 "camp.y"
    { (yyval.e) = (yyvsp[0].e); ;}
    break;

  case 87:
#line 394 "camp.y"
    { (yyval.e) = (yyvsp[0].e); ;}
    break;

  case 88:
#line 395 "camp.y"
    { (yyval.e) = new stringExp((yyvsp[0].ps).pos, *(yyvsp[0].ps).sym); ;}
    break;

  case 89:
#line 397 "camp.y"
    { (yyval.e) = new scaleExp((yyvsp[-1].e)->getPos(), (yyvsp[-1].e), (yyvsp[0].e)); ;}
    break;

  case 90:
#line 402 "camp.y"
    { (yyval.e) = new castExp((yyvsp[-2].n)->getPos(), new nameTy((yyvsp[-2].n)), (yyvsp[0].e)); ;}
    break;

  case 91:
#line 406 "camp.y"
    { (yyval.e) = new castExp((yyvsp[-3].n)->getPos(), new arrayTy((yyvsp[-3].n), (yyvsp[-2].dim)), (yyvsp[0].e)); ;}
    break;

  case 92:
#line 408 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 93:
#line 410 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 94:
#line 411 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 95:
#line 412 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 96:
#line 413 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 97:
#line 414 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 98:
#line 415 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 99:
#line 416 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 100:
#line 417 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 101:
#line 418 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 102:
#line 419 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 103:
#line 420 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 104:
#line 421 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 105:
#line 422 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 106:
#line 423 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 107:
#line 424 "camp.y"
    { (yyval.e) = new andExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 108:
#line 425 "camp.y"
    { (yyval.e) = new orExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 109:
#line 426 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 110:
#line 427 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 111:
#line 429 "camp.y"
    { (yyval.e) = new newRecordExp((yyvsp[-1].pos), (yyvsp[0].t)); ;}
    break;

  case 112:
#line 435 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-2].pos), (yyvsp[-1].t), (yyvsp[0].elist), 0, 0); ;}
    break;

  case 113:
#line 437 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-3].pos), (yyvsp[-2].t), (yyvsp[-1].elist), (yyvsp[0].dim), 0); ;}
    break;

  case 114:
#line 439 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-2].pos), (yyvsp[-1].t), 0, (yyvsp[0].dim), 0); ;}
    break;

  case 115:
#line 441 "camp.y"
    { (yyval.e) = new newArrayExp((yyvsp[-3].pos), (yyvsp[-2].t), 0, (yyvsp[-1].dim), (yyvsp[0].ai)); ;}
    break;

  case 116:
#line 443 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-4].pos), (yyvsp[-3].t), new formals((yyvsp[-2].pos)), (yyvsp[0].bs)); ;}
    break;

  case 117:
#line 445 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-5].pos),
                                             new arrayTy((yyvsp[-4].t)->getPos(), (yyvsp[-4].t), (yyvsp[-3].dim)),
                                             new formals((yyvsp[-2].pos)),
                                             (yyvsp[0].bs)); ;}
    break;

  case 118:
#line 450 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-5].pos), (yyvsp[-4].t), (yyvsp[-2].fls), (yyvsp[0].bs)); ;}
    break;

  case 119:
#line 452 "camp.y"
    { (yyval.e) = new newFunctionExp((yyvsp[-6].pos),
                                             new arrayTy((yyvsp[-5].t)->getPos(), (yyvsp[-5].t), (yyvsp[-4].dim)),
                                             (yyvsp[-2].fls),
                                             (yyvsp[0].bs)); ;}
    break;

  case 120:
#line 457 "camp.y"
    { (yyval.e) = new conditionalExp((yyvsp[-3].pos), (yyvsp[-4].e), (yyvsp[-2].e), (yyvsp[0].e)); ;}
    break;

  case 121:
#line 458 "camp.y"
    { (yyval.e) = new assignExp((yyvsp[-1].pos), (yyvsp[-2].e), (yyvsp[0].e)); ;}
    break;

  case 122:
#line 461 "camp.y"
    { (yyval.e) = new pairExp((yyvsp[-4].pos), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 123:
#line 463 "camp.y"
    { (yyval.e) = new tripleExp((yyvsp[-6].pos), (yyvsp[-5].e), (yyvsp[-3].e), (yyvsp[-1].e)); ;}
    break;

  case 124:
#line 465 "camp.y"
    { (yyvsp[-1].j)->pushFront((yyvsp[-2].e)); (yyvsp[-1].j)->pushBack((yyvsp[0].e)); (yyval.e) = (yyvsp[-1].j); ;}
    break;

  case 125:
#line 467 "camp.y"
    { (yyvsp[-1].j)->pushFront((yyvsp[-2].e));
                     (yyvsp[-1].j)->pushBack(new nullaryExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym));
                     (yyval.e) = (yyvsp[-1].j) ;}
    break;

  case 126:
#line 471 "camp.y"
    { (yyvsp[0].se)->setSide(camp::OUT);
                     joinExp *jexp =
                         new joinExp((yyvsp[0].se)->getPos(), symbol::trans(".."));
                     (yyval.e)=jexp;
                     jexp->pushBack((yyvsp[-1].e)); jexp->pushBack((yyvsp[0].se)); ;}
    break;

  case 127:
#line 477 "camp.y"
    { (yyval.e) = new prefixExp((yyvsp[-1].ps).pos, (yyvsp[0].e), symbol::trans("+")); ;}
    break;

  case 128:
#line 479 "camp.y"
    { (yyval.e) = new prefixExp((yyvsp[-1].ps).pos, (yyvsp[0].e), symbol::trans("-")); ;}
    break;

  case 129:
#line 482 "camp.y"
    { (yyval.e) = new postfixExp((yyvsp[0].ps).pos, (yyvsp[-1].e), symbol::trans("+")); ;}
    break;

  case 130:
#line 483 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 131:
#line 485 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 132:
#line 486 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 133:
#line 487 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 134:
#line 488 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 135:
#line 490 "camp.y"
    { (yyval.e) = new selfExp((yyvsp[-1].ps).pos, (yyvsp[-2].e), (yyvsp[-1].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 136:
#line 496 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos,(yyvsp[0].ps).sym); ;}
    break;

  case 137:
#line 498 "camp.y"
    { (yyval.j) = (yyvsp[0].j); ;}
    break;

  case 138:
#line 500 "camp.y"
    { (yyvsp[-1].se)->setSide(camp::OUT);
                     (yyval.j) = (yyvsp[0].j); (yyval.j)->pushFront((yyvsp[-1].se)); ;}
    break;

  case 139:
#line 503 "camp.y"
    { (yyvsp[0].se)->setSide(camp::IN);
                     (yyval.j) = (yyvsp[-1].j); (yyval.j)->pushBack((yyvsp[0].se)); ;}
    break;

  case 140:
#line 506 "camp.y"
    { (yyvsp[-2].se)->setSide(camp::OUT); (yyvsp[0].se)->setSide(camp::IN);
                     (yyval.j) = (yyvsp[-1].j); (yyval.j)->pushFront((yyvsp[-2].se)); (yyval.j)->pushBack((yyvsp[0].se)); ;}
    break;

  case 141:
#line 511 "camp.y"
    { (yyval.se) = new specExp((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym, (yyvsp[-1].e)); ;}
    break;

  case 142:
#line 512 "camp.y"
    { (yyval.se) = new specExp((yyvsp[-2].pos), symbol::opTrans("spec"), (yyvsp[-1].e)); ;}
    break;

  case 143:
#line 514 "camp.y"
    { (yyval.se) = new specExp((yyvsp[-4].pos), symbol::opTrans("spec"),
                                          new pairExp((yyvsp[-2].pos), (yyvsp[-3].e), (yyvsp[-1].e))); ;}
    break;

  case 144:
#line 519 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 145:
#line 521 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym); (yyval.j)->pushBack((yyvsp[-1].e)); ;}
    break;

  case 146:
#line 523 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[-2].ps).pos, (yyvsp[-2].ps).sym); (yyval.j)->pushBack((yyvsp[-1].e)); ;}
    break;

  case 147:
#line 524 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 148:
#line 525 "camp.y"
    { (yyval.j) = new joinExp((yyvsp[0].ps).pos, (yyvsp[0].ps).sym); ;}
    break;

  case 149:
#line 529 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym,
                              new booleanExp((yyvsp[-1].ps).pos, false)); ;}
    break;

  case 150:
#line 532 "camp.y"
    { (yyval.e) = new ternaryExp((yyvsp[-3].ps).pos, (yyvsp[-2].e), (yyvsp[-3].ps).sym, (yyvsp[0].e),
                              new booleanExp((yyvsp[-3].ps).pos, false)); ;}
    break;

  case 151:
#line 535 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-2].ps).pos, (yyvsp[0].e), (yyvsp[-2].ps).sym,
                              new booleanExp((yyvsp[-1].ps).pos, true)); ;}
    break;

  case 152:
#line 538 "camp.y"
    { (yyval.e) = new ternaryExp((yyvsp[-4].ps).pos, (yyvsp[-2].e), (yyvsp[-4].ps).sym, (yyvsp[0].e),
                              new booleanExp((yyvsp[-3].ps).pos, true)); ;}
    break;

  case 153:
#line 543 "camp.y"
    { (yyval.e) = new unaryExp((yyvsp[-1].ps).pos, (yyvsp[0].e), (yyvsp[-1].ps).sym); ;}
    break;

  case 154:
#line 545 "camp.y"
    { (yyval.e) = new binaryExp((yyvsp[-3].ps).pos, (yyvsp[-2].e), (yyvsp[-3].ps).sym, (yyvsp[0].e)); ;}
    break;

  case 155:
#line 549 "camp.y"
    { (yyval.s) = new emptyStm((yyvsp[0].pos)); ;}
    break;

  case 156:
#line 550 "camp.y"
    { (yyval.s) = (yyvsp[0].bs); ;}
    break;

  case 157:
#line 551 "camp.y"
    { (yyval.s) = (yyvsp[-1].s); ;}
    break;

  case 158:
#line 553 "camp.y"
    { (yyval.s) = new ifStm((yyvsp[-4].pos), (yyvsp[-2].e), (yyvsp[0].s)); ;}
    break;

  case 159:
#line 555 "camp.y"
    { (yyval.s) = new ifStm((yyvsp[-6].pos), (yyvsp[-4].e), (yyvsp[-2].s), (yyvsp[0].s)); ;}
    break;

  case 160:
#line 557 "camp.y"
    { (yyval.s) = new whileStm((yyvsp[-4].pos), (yyvsp[-2].e), (yyvsp[0].s)); ;}
    break;

  case 161:
#line 559 "camp.y"
    { (yyval.s) = new doStm((yyvsp[-6].pos), (yyvsp[-5].s), (yyvsp[-2].e)); ;}
    break;

  case 162:
#line 561 "camp.y"
    { (yyval.s) = new forStm((yyvsp[-8].pos), (yyvsp[-6].run), (yyvsp[-4].e), (yyvsp[-2].sel), (yyvsp[0].s)); ;}
    break;

  case 163:
#line 562 "camp.y"
    { (yyval.s) = new breakStm((yyvsp[-1].pos)); ;}
    break;

  case 164:
#line 563 "camp.y"
    { (yyval.s) = new continueStm((yyvsp[-1].pos)); ;}
    break;

  case 165:
#line 564 "camp.y"
    { (yyval.s) = new returnStm((yyvsp[-1].pos)); ;}
    break;

  case 166:
#line 565 "camp.y"
    { (yyval.s) = new returnStm((yyvsp[-2].pos), (yyvsp[-1].e)); ;}
    break;

  case 167:
#line 569 "camp.y"
    { (yyval.s) = new expStm((yyvsp[0].e)->getPos(), (yyvsp[0].e)); ;}
    break;

  case 168:
#line 573 "camp.y"
    { (yyval.run) = 0; ;}
    break;

  case 169:
#line 574 "camp.y"
    { (yyval.run) = (yyvsp[0].sel); ;}
    break;

  case 170:
#line 575 "camp.y"
    { (yyval.run) = (yyvsp[0].vd); ;}
    break;

  case 171:
#line 579 "camp.y"
    { (yyval.sel) = 0; ;}
    break;

  case 172:
#line 580 "camp.y"
    { (yyval.sel) = (yyvsp[0].sel); ;}
    break;

  case 173:
#line 584 "camp.y"
    { (yyval.sel) = new stmExpList((yyvsp[0].s)->getPos()); (yyval.sel)->add((yyvsp[0].s)); ;}
    break;

  case 174:
#line 586 "camp.y"
    { (yyval.sel) = (yyvsp[-2].sel); (yyval.sel)->add((yyvsp[0].s)); ;}
    break;


      default: break;
    }

/* Line 1056 of yacc.c.  */
#line 2704 "camp.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yystrlen (yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  _("syntax error, unexpected %s");
	  _("syntax error, unexpected %s, expecting %s");
	  _("syntax error, unexpected %s, expecting %s or %s");
	  _("syntax error, unexpected %s, expecting %s or %s or %s");
	  _("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yystrlen (yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = _(yyformat);
	  yysize1 = yysize + strlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp = yystpcpy (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror (_("syntax error; also memory exhausted"));
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct (_("Error: discarding"), yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct (_("Error: popping"), yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT (_("Shifting"), yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (yy_false)
     goto yyerrorlab;

  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror (_("parser stack overflow"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct (_("Error: discarding lookahead"),
		 yytoken, &yylval);
  if (yyssp != yyss)
    for (;;)
      {

	YYPOPSTACK;
	if (yyssp == yyss)
	  break;
	yydestruct (_("Error: popping"),
		    yystos[*yyssp], yyvsp);
      }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}



