/***** Autogenerated from runtime.in *****/
/*****
 * runtime.in
 * Tom Prince 2005/4/15
 *
 * Generated runtime functions.
 *
 *****/

#include "angle.h"
#include "pair.h"
#include "triple.h"
#include "transform.h"
#include "path.h"
#include "pen.h"
#include "guide.h"
#include "picture.h"
#include "drawpath.h"
#include "drawfill.h"
#include "drawclipbegin.h"
#include "drawclipend.h"
#include "drawlabel.h"
#include "drawverbatim.h"
#include "drawgsave.h"
#include "drawgrestore.h"
#include "drawlayer.h"
#include "drawimage.h"
#include "drawgroup.h"
#include "fileio.h"
#include "genv.h"
#include "builtin.h"
#include "texfile.h"
#include "pipestream.h"
#include "parser.h"
#include "stack.h"
  
using namespace vm;
using namespace camp;
using namespace settings;

namespace run {
using camp::pair;
using mem::string;
}
namespace trans {
using namespace types;
}



namespace run {

void gen0__label(vm::stack *gen_theStack)
{
  pen * p = vm::pop<pen *>(gen_theStack);
  pair a = vm::pop<pair>(gen_theStack);
  pair z = vm::pop<pair>(gen_theStack);
  double r = vm::pop<double>(gen_theStack);
  string * t = vm::pop<string *>(gen_theStack);
  picture * pic = vm::pop<picture *>(gen_theStack);

  drawLabel *d = new drawLabel(*t,r,z,a,p);
  pic->append(d);
}

void gen1_basealign(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);

  { gen_theStack->push<pen*>(new pen(n >= 0 && n < nBaseLine 
                   ? (BaseLine) n
                   : DEFBASE)); return; }
}

void gen2_draw(vm::stack *gen_theStack)
{
  pen * n = vm::pop<pen *>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);
  picture * pic = vm::pop<picture *>(gen_theStack);

  drawPath *d = new drawPath(p,*n);
  pic->append(d);
}

void gen3_fill(vm::stack *gen_theStack)
{
  double rb = vm::pop<double>(gen_theStack);
  pair b = vm::pop<pair>(gen_theStack);
  pen * penb = vm::pop<pen *>(gen_theStack);
  double ra = vm::pop<double>(gen_theStack);
  pair a = vm::pop<pair>(gen_theStack);
  pen * pena = vm::pop<pen *>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);
  picture * pic = vm::pop<picture *>(gen_theStack);

  drawFill *d = new drawFill(p,*pena,a,ra,*penb,b,rb);
  pic->append(d);
}

// Clip a picture to a path using the given fill rule.
// Subsequent additions to the picture will not be affected by the path.
void gen4_clip(vm::stack *gen_theStack)
{
  pen * n = vm::pop<pen *>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->prepend(new drawClipBegin(p,*n));
  pic->append(new drawClipEnd());
}

void gen5_beginclip(vm::stack *gen_theStack)
{
  pen * n = vm::pop<pen *>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->append(new drawClipBegin(p,*n,false));
}

void gen6_endclip(vm::stack *gen_theStack)
{
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->append(new drawClipEnd(false));
}

void gen7_gsave(vm::stack *gen_theStack)
{
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->append(new drawGsave());
}

void gen8_grestore(vm::stack *gen_theStack)
{
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->append(new drawGrestore());
}

void gen9_begingroup(vm::stack *gen_theStack)
{
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->append(new drawBegin());
}

void gen10_endgroup(vm::stack *gen_theStack)
{
  picture * pic = vm::pop<picture *>(gen_theStack);

  pic->append(new drawEnd());
}

void gen11_add(vm::stack *gen_theStack)
{
  picture * from = vm::pop<picture *>(gen_theStack);
  picture * to = vm::pop<picture *>(gen_theStack);

  to->add(*from);
}

void gen12_prepend(vm::stack *gen_theStack)
{
  picture * from = vm::pop<picture *>(gen_theStack);
  picture * to = vm::pop<picture *>(gen_theStack);

  to->prepend(*from);
}

void gen13_fileprefix(vm::stack *gen_theStack)
{

  { gen_theStack->push<string>(outname); return; }
}

// Interactive mode
void gen14_interact(vm::stack *gen_theStack)
{
  bool interaction = vm::pop<bool>(gen_theStack);

  if(interact::interactive) settings::suppressStandard=!interaction;
}

void gen15_interact(vm::stack *gen_theStack)
{

  { gen_theStack->push<bool>(interact::interactive && !settings::suppressStandard); return; }
}

// System commands
void gen16_system(vm::stack *gen_theStack)
{
  string * str = vm::pop<string *>(gen_theStack);

  if(settings::suppressStandard) { gen_theStack->push<int>(0); return; }
  
  if(safe) error("system() call disabled; override with option -unsafe");
  else { gen_theStack->push<int>(System(str->c_str())); return; }
}

void gen17_abort(vm::stack *gen_theStack)
{
  string * msg = vm::pop<string *>(gen_theStack);

  error(msg->c_str());
}

// Path operations
void gen18_point(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(p.point(n)); return; }
}

void gen19_point(vm::stack *gen_theStack)
{
  double t = vm::pop<double>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(p.point(t)); return; }
}

void gen20_precontrol(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(p.precontrol(n)); return; }
}

void gen21_precontrol(vm::stack *gen_theStack)
{
  double t = vm::pop<double>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(p.precontrol(t)); return; }
}

void gen22_postcontrol(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(p.postcontrol(n)); return; }
}

void gen23_postcontrol(vm::stack *gen_theStack)
{
  double t = vm::pop<double>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(p.postcontrol(t)); return; }
}

void gen24_dir(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(unit(p.direction(n))); return; }
}

void gen25_dir(vm::stack *gen_theStack)
{
  double t = vm::pop<double>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(unit(p.direction(t))); return; }
}

void gen26_reverse(vm::stack *gen_theStack)
{
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<path>(p.reverse()); return; }
}

void gen27_subpath(vm::stack *gen_theStack)
{
  int e = vm::pop<int>(gen_theStack);
  int b = vm::pop<int>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<path>(p.subpath(b,e)); return; }
}

void gen28_subpath(vm::stack *gen_theStack)
{
  double e = vm::pop<double>(gen_theStack);
  double b = vm::pop<double>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<path>(p.subpath(b,e)); return; }
}

void gen29_length(vm::stack *gen_theStack)
{
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<int>(p.length()); return; }
}

void gen30_cyclic(vm::stack *gen_theStack)
{
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<bool>(p.cyclic()); return; }
}

void gen31_straight(vm::stack *gen_theStack)
{
  int i = vm::pop<int>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<bool>(p.straight(i)); return; }
}

void gen32_arclength(vm::stack *gen_theStack)
{
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<double>(p.arclength()); return; }
}

void gen33_arctime(vm::stack *gen_theStack)
{
  double dval = vm::pop<double>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<double>(p.arctime(dval)); return; }
}

void gen34_dirtime(vm::stack *gen_theStack)
{
  pair z = vm::pop<pair>(gen_theStack);
  path p = vm::pop<path>(gen_theStack);

  { gen_theStack->push<double>(p.directiontime(z)); return; }
}

void gen35_intersect(vm::stack *gen_theStack)
{
  path y = vm::pop<path>(gen_theStack);
  path x = vm::pop<path>(gen_theStack);

  { gen_theStack->push<pair>(intersectiontime(x,y)); return; }
}

void gen36_length(vm::stack *gen_theStack)
{
  string * s = vm::pop<string *>(gen_theStack);

  { gen_theStack->push<int>((int) s->length()); return; }
}

void gen37_find(vm::stack *gen_theStack)
{
  int pos = vm::pop<int>(gen_theStack);
  string * sub = vm::pop<string *>(gen_theStack);
  string * s = vm::pop<string *>(gen_theStack);

  { gen_theStack->push<int>((int) s->find(*sub,pos)); return; }
}

void gen38_rfind(vm::stack *gen_theStack)
{
  int pos = vm::pop<int>(gen_theStack);
  string * sub = vm::pop<string *>(gen_theStack);
  string * s = vm::pop<string *>(gen_theStack);

  { gen_theStack->push<int>((int) s->rfind(*sub,pos)); return; }
}

void gen39_reverse(vm::stack *gen_theStack)
{
  string s = vm::pop<string>(gen_theStack);

  reverse(s.begin(),s.end());
  { gen_theStack->push<string>(s); return; }
}

void gen40_insert(vm::stack *gen_theStack)
{
  string * sub = vm::pop<string *>(gen_theStack);
  int pos = vm::pop<int>(gen_theStack);
  string s = vm::pop<string>(gen_theStack);

  if ((size_t)pos < s.length())
    { gen_theStack->push<string>(s.insert(pos,*sub)); return; }
  { gen_theStack->push<string>(s); return; }
}

void gen41_substr(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);
  int pos = vm::pop<int>(gen_theStack);
  string* s = vm::pop<string*>(gen_theStack);

  if ((size_t)pos < s->length())
    { gen_theStack->push<string>(s->substr(pos,n)); return; }
  { gen_theStack->push<string>(""); return; } // TODO: Make this shared again.
}

void gen42_erase(vm::stack *gen_theStack)
{
  int n = vm::pop<int>(gen_theStack);
  int pos = vm::pop<int>(gen_theStack);
  string s = vm::pop<string>(gen_theStack);

  if ((size_t)pos < s.length())
    { gen_theStack->push<string>(s.erase(pos,n)); return; }
  { gen_theStack->push<string>(s); return; } 
}

} // namespace run

namespace trans {

void gen_base_venv(venv &ve)
{
  addFunc(ve, run::gen0__label, primVoid(), "_label", primPicture(), primString(), primReal(), primPair(), primPair(), primPen());
  addFunc(ve, run::gen1_basealign, primPen(), "basealign", primInt());
  addFunc(ve, run::gen2_draw, primVoid(), "draw", primPicture(), primPath(), primPen());
  addFunc(ve, run::gen3_fill, primVoid(), "fill", primPicture(), primPath(), primPen(), primPair(), primReal(), primPen(), primPair(), primReal());
  addFunc(ve, run::gen4_clip, primVoid(), "clip", primPicture(), primPath(), primPen());
  addFunc(ve, run::gen5_beginclip, primVoid(), "beginclip", primPicture(), primPath(), primPen());
  addFunc(ve, run::gen6_endclip, primVoid(), "endclip", primPicture());
  addFunc(ve, run::gen7_gsave, primVoid(), "gsave", primPicture());
  addFunc(ve, run::gen8_grestore, primVoid(), "grestore", primPicture());
  addFunc(ve, run::gen9_begingroup, primVoid(), "begingroup", primPicture());
  addFunc(ve, run::gen10_endgroup, primVoid(), "endgroup", primPicture());
  addFunc(ve, run::gen11_add, primVoid(), "add", primPicture(), primPicture());
  addFunc(ve, run::gen12_prepend, primVoid(), "prepend", primPicture(), primPicture());
  addFunc(ve, run::gen13_fileprefix, primString() , "fileprefix");
  addFunc(ve, run::gen14_interact, primVoid(), "interact", primBoolean());
  addFunc(ve, run::gen15_interact, primBoolean(), "interact");
  addFunc(ve, run::gen16_system, primInt(), "system", primString());
  addFunc(ve, run::gen17_abort, primVoid(), "abort", primString());
  addFunc(ve, run::gen18_point, primPair(), "point", primPath(), primInt());
  addFunc(ve, run::gen19_point, primPair(), "point", primPath(), primReal());
  addFunc(ve, run::gen20_precontrol, primPair(), "precontrol", primPath(), primInt());
  addFunc(ve, run::gen21_precontrol, primPair(), "precontrol", primPath(), primReal());
  addFunc(ve, run::gen22_postcontrol, primPair(), "postcontrol", primPath(), primInt());
  addFunc(ve, run::gen23_postcontrol, primPair(), "postcontrol", primPath(), primReal());
  addFunc(ve, run::gen24_dir, primPair(), "dir", primPath(), primInt());
  addFunc(ve, run::gen25_dir, primPair(), "dir", primPath(), primReal());
  addFunc(ve, run::gen26_reverse, primPath(), "reverse", primPath());
  addFunc(ve, run::gen27_subpath, primPath(), "subpath", primPath(), primInt(), primInt());
  addFunc(ve, run::gen28_subpath, primPath(), "subpath", primPath(), primReal(), primReal());
  addFunc(ve, run::gen29_length, primInt(), "length", primPath());
  addFunc(ve, run::gen30_cyclic, primBoolean(), "cyclic", primPath());
  addFunc(ve, run::gen31_straight, primBoolean(), "straight", primPath(), primInt());
  addFunc(ve, run::gen32_arclength, primReal(), "arclength", primPath());
  addFunc(ve, run::gen33_arctime, primReal(), "arctime", primPath(), primReal());
  addFunc(ve, run::gen34_dirtime, primReal(), "dirtime", primPath(), primPair());
  addFunc(ve, run::gen35_intersect, primPair(), "intersect", primPath(), primPath());
  addFunc(ve, run::gen36_length, primInt(), "length", primString());
  addFunc(ve, run::gen37_find, primInt(), "find", primString(), primString(), primInt());
  addFunc(ve, run::gen38_rfind, primInt(), "rfind", primString(), primString(), primInt());
  addFunc(ve, run::gen39_reverse, primString() , "reverse", primString() );
  addFunc(ve, run::gen40_insert, primString() , "insert", primString() , primInt(), primString());
  addFunc(ve, run::gen41_substr, primString() , "substr", primString(), primInt(), primInt());
  addFunc(ve, run::gen42_erase, primString() , "erase", primString() , primInt(), primInt());
}

} // namesapce trans
